function [x1,x2,DDX1,DDX2,DDY1,DDY2,indx1,indx2,indy1,indy2] = SUB_Init2D_v1_20201130(nx,ny,overlap)

a=-overlap/2; b=-a;                         % boundaries of two domains
x=linspace(-1,1,nx)'; y=linspace(-1,1,ny)'; % x and y coordinates
hx=x(2)-x(1); hy=y(2)-y(1);
x1=x(x<=b); b=x1(end);                      % leftmost domain
x2=x(x>=a); a=x2(1);                        % rightmost domain
l1=length(x1); l2=length(x2);               % domain sizes

[~,ddx1]=MAT_FD_v1_20201113(l1,hx);         % 2nd order differentiation
[~,ddx2]=MAT_FD_v1_20201113(l2,hx);         % matrices (finite differences)
[~,ddy] =MAT_FD_v1_20201113(ny,hy);         % for both domains, in both directions

Ix1=speye(l1); Ix2=speye(l2); Iy=speye(ny); % identity matrices in x and y
DDX1=kron(Iy,ddx1);                         % 2D 2nd order differentiation
DDX2=kron(Iy,ddx2);                         % matrices for both domains,
DDY1=kron(ddy,Ix1);                         % in both directions
DDY2=kron(ddy,Ix2);
indx1=kron([0;ones(ny-2,1);0],[1;zeros(l1-2,1);1])==1;   % index of x-boundary in domain 1
indx2=kron([0;ones(ny-2,1);0],[1;zeros(l2-2,1);1])==1;   % "" in domain 2
indy1=kron([1;zeros(ny-2,1);1],ones(l1,1))==1;   % index of y-boundary ""
indy2=kron([1;zeros(ny-2,1);1],ones(l2,1))==1;   % "" in domain 2
% NB: for the four corners the BCs in y are used and not the BCs in x

DDX1(indy1,:)=0; DDX2(indy2,:)=0;
DDY1(indx1,:)=0; DDY2(indx2,:)=0;
II1=kron(Iy,Ix1); II2=kron(Iy,Ix2);
DDX1(indx1,:)=II1(indx1,:);
DDX2(indx2,:)=II2(indx2,:);
DDY1(indy1,:)=II1(indy1,:);
DDY2(indy2,:)=II2(indy2,:);

end